From 523f8613c124b722b721c8055db2085a005e09dd Mon Sep 17 00:00:00 2001
From: Andreas Sturmlechner <asturm@gentoo.org>
Date: Fri, 6 Nov 2020 02:43:07 +0100
Subject: [PATCH] Fix build with ICU 68, use standard true. (part 2/2 missing
 from 0b14b9ec)

Change-Id: I776dd4e1fc92ef1ef09b88e239bf0d6942c28ca3
Signed-off-by: Andreas Sturmlechner <asturm@gentoo.org>
---
 svx/source/dialog/fntctrl.cxx | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/svx/source/dialog/fntctrl.cxx b/svx/source/dialog/fntctrl.cxx
index d312d7ad5f49..10c84ca95222 100644
--- a/svx/source/dialog/fntctrl.cxx
+++ b/svx/source/dialog/fntctrl.cxx
@@ -1014,7 +1014,7 @@ void SvxFontPrevWindow::SetFromItemSet(const SfxItemSet &rSet, bool bPreviewBack
          rCTLFont.SetFillColor( rColor );
     }
     else
-        bTransparent = TRUE;
+        bTransparent = true;
 
     rFont.SetTransparent( bTransparent );
     rCJKFont.SetTransparent( bTransparent );
-- 
2.29.2