From e9320e567d6bca32783d0f716f386761d03a875a Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Caol=C3=A1n=20McNamara?= <caolan.mcnamara@collabora.com>
Date: Mon, 13 Nov 2023 10:13:50 +0000
Subject: upgrade libcmis
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Change-Id: Ie2d5f3f8208f9952db5be10905b5905cd03b91de
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/159366
Tested-by: Jenkins
Reviewed-by: Caolán McNamara <caolan.mcnamara@collabora.com>
(cherry picked from commit 3368447e826d4204086e4d8bfe59af4412c16233)
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/159454
Reviewed-by: Michael Stahl <michael.stahl@allotropia.de>
(cherry picked from commit 25b159729f1202ca2a42de5e76f22718d68400c8)
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/159589
---
 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

(limited to 'configure.ac')

diff --git a/configure.ac b/configure.ac
index a88c81646c40..bdd08abeeeb5 100644
--- a/configure.ac
+++ b/configure.ac
@@ -7532,7 +7532,7 @@ AC_SUBST(GPERF)
 dnl ===================================================================
 dnl Check for system libcmis
 dnl ===================================================================
-libo_CHECK_SYSTEM_MODULE([libcmis],[LIBCMIS],[libcmis-0.5 >= 0.5.2],enabled)
+libo_CHECK_SYSTEM_MODULE([libcmis],[LIBCMIS],[libcmis-0.6 >= 0.6.1],enabled)
 
 dnl ===================================================================
 dnl C++11
-- 
cgit v1.2.1